/*******************************************
 * DMAŃVAʐM
 * @Weater Click : I2C  UART5+DMA
 *   PIC18F57Q43
 *******************************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/weather.h"
#include <string.h>
// ϐ`
uint8_t Msg[];            // Use 39
uint8_t Flag;

/************************
 * ^C}0@Callback֐
 ************************/
void TMR0_Process(void){
    Flag = 1;
    LED_Toggle();
}

/****** C֐ ***************/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}0 Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    /****** C[v ******************/
    while (1)
    {
        if(Flag == 1){                                  // tOȈꍇ
            Flag = 0;                                   // tOZbg
            // WeatherZTf[^擾
            Weather_readSensors();
            // UARTbZ[W쐬@xACAx̃f[^
            sprintf(Msg, "T=%-2.1f DegC  P=%-4.1f hPa  H=%-2.1f %%RH\r\n", 
                Weather_getTemperatureDegC(), Weather_getPressureKPa()*10, Weather_getHumidityRH()); 
            // DMAMs
            DMAnCON0bits.AIRQEN = 1;                    // DMA1~ݒ
            DMA1_StartTransferWithTrigger();            // DMA1JniUARTM)            
        }
    }
}
