/***************************************************
 *  `E|}[d}l[W
 * @1bԊuŌvl\
 *@40bԊuŃOt\@@3.0Vŕd~
 *  PIC18F27Q43 + MCP73827 + MCP6292(OPA)
***************************************************/
#include "mcc_generated_files/mcc.h"
#include "colorlcd28.h"
#include <string.h>
// O[oϐA萔`
const uint8_t Title[] = {0x81,0x79,0x83,0x8A,0x83,0x60,0x83,0x45,0x83,0x80,
    0x83,0x6F,0x83,0x62,0x83,0x65,0x83,0x8A,0x81,0x40,0x8F,0x5B,0x95,0xFA,0x93,0x64,
    0x83,0x7D,0x83,0x6C,0x81,0x5B,0x83,0x57,0x83,0x83,0x81,0x7A,0x00,0x00};
uint8_t Msg1[10], Msg2[10];
uint8_t Msg3[] = "Start Charge";
uint8_t Msg4[] = " 0    0.5   1.0  1.5   2.0  2.5   3.0";
uint8_t Msg5[] = "Hour";
uint8_t Msg6[] = {0x8F,0x5B,0x93,0x64,0x00,0x00};
uint8_t Msg7[] = {0x95,0xFA,0x93,0x64,0x00,0x00};
volatile uint8_t Flag;
uint16_t result, Interval, DisFlag;
int16_t i, Index;
double time, ChgCurrent, ChgVolt, DisCurrent, DisVoltage;
uint16_t Current[500], Volt[500], DisCur[500], DisVolt[500];
/****************************************
 * Timer1 荞ݏ@1b
 ***************************************/
void T1_Proc(void){
    Green_Toggle();
    Flag = 1;
}
/******* C֐ ******************/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}1荞ݏ֐`
    TMR1_SetInterruptHandler(T1_Proc);
    // LCD
    lcd_Init();                             // LCD
    lcd_Clear(BLACK);                       // LCDS
    // o\
    Kanji_Str(1, 0, Title, GREEN, BLACK);
    //@OtW\
    time = 0;
    for(i=0; i<7; i++){
        lcd_Line(10, i*33+18, 319, i*33+18, BLUE);  // 
        lcd_sChar(0, 27-i*4, (uint8_t)(i+0x30), WHITE, BLACK);
    }
    for(i=0; i<7; i++){
        lcd_Line(i*45+10, 18, i*45+10, 231, BLUE);  // c
    }
    lcd_sStr(0, 28, Msg4, WHITE, BLACK);
    lcd_sStr(17, 29, Msg5, WHITE, BLACK);      
    // ϐ
    Index = 0;
    Interval = 40;
    DisFlag = 0;                                     // dJntO  
    Stop_SetDigitalInput();                          // d~J
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    /*******C[v  ************************/
    while (1)
    {
        if(Flag == 1){                                      // 1b҂
            Flag = 0;
            // [dd̑
            result = ADCC_GetSingleConversion(ChgA);        // dv
            ChgCurrent = 10000*(3.3*result)/(4095*26.0);    // dlɕϊ
            Current[Index] = (uint16_t)(ChgCurrent * 0.33); // OtpXP[ϊۑ
            Kanji_Str(9, 1, Msg6, WHITE,BLACK);             // [d
            sprintf(Msg1, "%3.0f mA", ChgCurrent);          // ɕϊ
            lcd_sStr(18, 2, Msg1, RED, BLACK);              // d\
            // [dd̑
            result = ADCC_GetSingleConversion(ChgV);        // dv
            ChgVolt = (2 * 3.3 * result)/4095;              // dlɕϊ
            Volt[Index] = (uint16_t)(ChgVolt * 33);         // Otpۑ
            sprintf(Msg2, "%1.2fVolt", ChgVolt);            // ɕϊ
            lcd_sStr(18, 4, Msg2, GREEN, BLACK);            // d\          
            // dd̑
            result = ADCC_GetSingleConversion(DisA);        // dv
            DisCurrent = 10000*(3.3*result)/(4095*16.0);    // dlɕϊ
            DisCur[Index] = (uint16_t)(DisCurrent * 0.33);  // Otpۑ
            // dd̑
            result = ADCC_GetSingleConversion(DisV);        // dv
            DisVoltage = (2 * 3.3 * result)/4095;           // dlɕϊ
            DisVolt[Index] = (uint16_t)(DisVoltage * 33);   // Otpۑ
            // ddɂ`FbN
            if((DisFlag) && (DisVoltage < 3.0)){            // 3.0Vȉ
                Stop_SetLow();                              // oLow
                Stop_SetDigitalOutput();                    // d~
            }
            if((DisFlag == 0) && (DisVoltage > 1.0)){       // dڑ
                DisFlag = 1;                                // dtOI
                Stop_SetDigitalInput();                     // ~
            }            
            // dddl̕\
            if(DisFlag){                                    // d̏ꍇ̂ݕ\
                Kanji_Str(18, 1, Msg7, WHITE,BLACK);        // d
                sprintf(Msg1, "%3.0f mA", DisCurrent);      // ɕϊ
                lcd_sStr(31, 2, Msg1, YELLOW, BLACK);       // d\            
                sprintf(Msg2, "%1.2fVolt", DisVoltage);     // ɕϊ
                lcd_sStr(31, 4, Msg2, CYAN, BLACK);         // d\               
            }
            //***** Ot` *****
            Interval--;                                     // 40b
            if(Interval == 0){
                Interval = 40;
                // Otvbg
                if(Index > 1){
                    lcd_Line(Index-1+10, (int16_t)Current[Index-1]+18, Index+10, (int16_t)Current[Index]+18, RED);
                    lcd_Line(Index-1+10, (int16_t)Volt[Index-1]+18, Index+10, (int16_t)Volt[Index]+18, GREEN);
                    if(DisFlag){                            // d̏ꍇ̂ݕ\
                        lcd_Line(Index-1+10, (int16_t)DisCur[Index-1]+18, Index+10, (int16_t)DisCur[Index]+18, YELLOW);
                        lcd_Line(Index-1+10, (int16_t)DisVolt[Index-1]+18, Index+10, (int16_t)DisVolt[Index]+18, CYAN);  
                    }
                }
                Index++;                                    // ̍W
                if(Index > 319)                             // őŃZbg
                    Index = 0;                
            }
            // [dIC̃[h\@LED
            if(Mode_GetValue() == 1)
                Red_SetHigh();
            else
                Red_SetLow();
        }   
        //*********** S1Iōĕ` **************
        if(S1_GetValue() == 0){
            lcd_Clear(BLACK);
            // o\
             Kanji_Str(1, 0, Title, GREEN, BLACK);            
            //@OtW\
            time = 0;
            for(i=0; i<7; i++){
                lcd_Line(10, i*33+18, 319, i*33+18, BLUE);      // 
                lcd_sChar(0, 27-i*4, (uint8_t)(i+0x30), WHITE, BLACK);  // Y
            }
            for(i=0; i<7; i++){
                lcd_Line(i*45+10, 18, i*45+10, 231, BLUE);      // c
            }
            lcd_sStr(0, 28, Msg4, WHITE, BLACK);
            lcd_sStr(17, 29, Msg5, WHITE, BLACK);              
            // OtS̍ĕ`
            for(i=1; i<=Index; i++){
                lcd_Line(i-1+10, (int16_t)Current[i-1]+18, i+10, (int16_t)Current[i]+18, RED);
                lcd_Line(i-1+10, (int16_t)Volt[i-1]+18, i+10, (int16_t)Volt[i]+18, GREEN);
                if(DisFlag){
                    lcd_Line(i-1+10, (int16_t)DisCur[i-1]+18, i+10, (int16_t)DisCur[i]+18, YELLOW);
                    lcd_Line(i-1+10, (int16_t)DisVolt[i-1]+18, i+10,(int16_t) DisVolt[i]+18, CYAN);
                }
            }
        }
    }
}
