/*************************************************
 *  GPSK[@@MCCgp
 * @PIC18F27Q43@ROM 128kB@RAM 8kB
 * @FATt@CVXe@@SPI1  4MHz
 * @OLEDOtBbN       SPI2@4MHz
 *   GPS  UART1 9600bps 荞
 * @tHg@12x12hbg ANK{o^
**************************************************/
#include "mcc_generated_files/mcc.h"
#include "OLED_lib.h"
#include <string.h>
// ϐ`
volatile uint8_t Flag;
char Index, rData[120], GPGGA[120];
char Data[40], rcv;
unsigned long Log_Flag, No;
int time, HiOld, Hi;
const char Head[] = "$GPGGA";
char temp[15], min[10],hour[3],ido[13],N[2],keido[14],E[2],S[2],D[5],M[2],G[8],jikoku[7],kyori[6], koudo[5];
double ftemp;
const uint8_t Msg1[] = {0x86, 0x9A, 0};         // 
const uint8_t Msg2[] = {0x8C, 0x8D, 0};         // ܓx
const uint8_t Msg3[] = {0x8E, 0x8D, 0};         // ox
const uint8_t Msg5[] = {0x92, 0x8D, 0};         // x
const uint8_t Msg6[] = {0x98, 0x99, 0x20, 0};   // q
const uint8_t Msg7[] = {0x9D,0x9E,0x9F,0xC5,0}; //M҂
// t@CVXe֘A
char File1[] = "LG000000";                      // Ot@C
char File2[] = ".txt";                          // Ot@Cgq
char FileName[13];                              // t@C
FRESULT result;
FATFS drive;
FIL file;
UINT actualLength;

/******@C֐@**************/
void main(void)
{
    SYSTEM_Initialize();                            // VXe
    // OLED
    OLED_Init();
    OLED_Clear(BLACK);
    OLED_xStr(0, 0, Msg1, GREEN, BLACK);    // \
    OLED_xStr(3, 0, (uint8_t *)Msg7, RED, BLACK);//M҂
    OLED_xStr(0, 1, Msg2, YELLOW, BLACK);   // ܓx̕\
    OLED_xStr(0, 2, Msg3, YELLOW, BLACK);   // ox̏̕\
    OLED_xStr(0, 3, Msg6, WHITE, BLACK);    // q̕\
    OLED_xStr(0, 4, Msg5, WHITE, BLACK);    // x̕\    
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    /**** C[v ***************/
    while (1)
    {
        /******* XCb`̃`FbN***********/
        if(S2_GetValue() == 0){
            __delay_ms(200);             
            while(S2_GetValue() == 0);              // `b^
            __delay_ms(200);            
            if(Log_Flag == 1){                       // Os̏ꍇ
                Log_Flag = 0;                        // OI
                Red_SetLow();
            }
            else{                                   // Os̏ꍇ
                Log_Flag = 1;                       // OJn
                Red_SetHigh();
                FileName[0] = 0;                    // 񃊃Zbg
                strcpy(File1+2, jikoku);            // t@CɎݒ                
                strcat(FileName, File1);            // Ot@C쐬
                strcat(FileName, File2);            // gqǉ                
            }
        } 
        /**** GPSMi荞݁jobt@64oCg ***********/
        if(UART1_is_rx_ready())
        {
            rcv = UART1_Read();   
            if(rcv != 0x0A){                        // f[^I܂ŌJԂ
                if(rcv == ',')                      // J}̏ꍇ
                    rcv = ' ';                      // Xy[Xɕϊ
                rData[Index++] = rcv;               // obt@ɒǉ
            }
            else{                                   // f[^Ȉꍇ
                rData[Index-1] = 0;                 // 0DA0A̍폜
                rData[Index-2] = 0;
                if(strncmp(rData, Head, 6) == 0){   // wb_`FbN
                    strcpy(GPGGA, rData);           // obt@Rs[
                    Flag = 1;                       // MtOI
                }
                Index = 0;                          // ̃bZ[W 
            }
        }
        /********* GPGGA̎Mi1bƁj *****************/
        if(Flag == 1){                              // tOmF
            Flag = 0;
            HiOld = Hi;
            // Xy[X؂ōڂƂɐU蕪
            sscanf(GPGGA, "%s %s %s %s %s %s %s %d %s %d %s %s ",temp,min,ido,N,keido,E,S,&No,D,&Hi,M,G);
            //f[^mF
            if(N[0] == 'N'){                                    // f[^
                strncpy(jikoku, min, 6);                        // o
                strncpy(hour, min, 2);                          // ԕo
                time = atoi(hour);                              // Ԃ𐔒l
                //@̕␳@+9ԁ@24-24
                time = time + 9;                                // {9
                if(time >=24)                                   // 24̏ꍇ
                    time -= 24;                                 // -24
                sprintf(hour, "%02d", time);                    // Ԃ𕶎
                jikoku[0] = hour[0];                            // ɎԂRs[
                jikoku[1] = hour[1];
                OLED_xStr(0, 0, Msg1, GREEN, BLACK);            // \
                OLED_xStr(2, 0, (uint8_t *)jikoku, GREEN, BLACK);          
                // ܓx60i->10iϊ
                strncpy(temp, ido+2, 7);                        // ̕؂o
                ftemp = atof(temp) / 60.0;                      // ɕϊ1/60
                sprintf(temp, "%0.6f", ftemp);                  // ɕϊ
                strncpy(ido+2, temp+1, 6);                      // ido̓xɒǉ
                ido[8] = 0;                                     // ̏Iǉ
                OLED_xStr(0, 1, Msg2, YELLOW, BLACK);           // ܓx̕\
                OLED_xStr(2, 1, (uint8_t *)ido+2, YELLOW, BLACK);
                // ox60i->10iϊ
                strncpy(temp, keido+3, 7);                      // ̐̕؂o
                ftemp = atof(temp) / 60.0;                      // ɕϊ1/60
                sprintf(temp, "%0.6f", ftemp);                  // ɕϊ
                strncpy(keido+3, temp+1, 6);                    // keido̓xɒǉ
                keido[9] = 0;                                   // ̏Iǉ
                OLED_xStr(0, 2, Msg3, YELLOW, BLACK);           // ox̏̕\
                OLED_xStr(2, 2, (uint8_t *)keido+3, YELLOW, BLACK); 
                // q̕\
                OLED_xStr(0, 3, Msg6, WHITE, BLACK);            // Mqo
                sprintf(temp, "%02d", No);                      // 2ŕɕϊ
                temp[2] = 0;
                OLED_xStr(3, 3, (uint8_t *)temp, WHITE, BLACK); // \o
                // x̕\
                OLED_xStr(0, 4, Msg5, WHITE, BLACK);            // x̃f[^o
                sprintf(koudo, "%04d", (int)((Hi+HiOld)/2));    // 4ŕɕϊ
                koudo[4] = 0;
                OLED_xStr(3, 4, (uint8_t *)koudo, WHITE, BLACK);// \o                
                /*********** Osi15bƁj ***********/
                if(Log_Flag == 1){
                    strncpy(temp, jikoku+4, 2);                 // b؂o
                    if((atoi(temp) % 15) == 0){                 // 15b
                        /*** Of[^ ***/
                        strncpy(Data, jikoku, 6);               // ̃Rs[
                        *(Data+6) = ',';
                        strncpy(Data+7, ido, 8);                // ܓx̃Rs[
                        *(Data+15) = ',';
                        strncpy(Data+16, keido, 9);             // ox̃Rs[
                        *(Data+25) = ',';
                        strncpy(Data+26, koudo, 4);             // x̃Rs[
                        *(Data+30) = 0x0D;
                        *(Data+31) = 0x0A;
                        *(Data+32) = 0;
                        /******* SDJ[hɏ **************/                       
                        if( SD_SPI_IsMediaPresent() == false) {
                            return;
                        }
                        if (f_mount(&drive,"0:",1) != FR_OK) {  // }Eg
                            return;
                        }
                        else{                                   // t@CI[v
                            if (f_open(&file, FileName,  FA_WRITE | FA_OPEN_APPEND) == FR_OK){
                                Green_SetHigh();
                            }
                            else{
                                return;
                            }
                        }
                        f_write(&file, Data, strlen(Data), &actualLength );     // ݎs
                        f_close(&file);                                         // N[Y
                        f_mount(0,"0:",0);                                      // A}Eg
                        Green_SetLow();                           
                    } 
                }
            }
        }
    }
}
